package com.liang.dao;

import com.liang.entity.PrjApproverecord;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 科技项目审批(PrjApproverecord)表数据库访问层
 *
 * @author makejava
 * @since 2023-05-03 13:23:10
 */
public interface PrjApproverecordDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjApproverecord queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjApproverecord 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<PrjApproverecord> queryAllByLimit(PrjApproverecord prjApproverecord, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjApproverecord 查询条件
     * @return 总行数
     */
    long count(PrjApproverecord prjApproverecord);

    /**
     * 新增数据
     *
     * @param prjApproverecord 实例对象
     * @return 影响行数
     */
    int insert(PrjApproverecord prjApproverecord);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjApproverecord> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjApproverecord> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjApproverecord> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjApproverecord> entities);

    /**
     * 修改数据
     *
     * @param prjApproverecord 实例对象
     * @return 影响行数
     */
    int update(PrjApproverecord prjApproverecord);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取待审批列表
     *
     * @return
     */
    List<PrjApproverecord> getApproveList(Map map);

    /**
     * 修改费用申请撤销时的状态为完成
     *
     * @param xmid
     * @return
     */
    int updateRevokeRecord(int xmid);

    /**
     * 根据项目ID获取待审批记录
     *
     * @return
     */
    List<PrjApproverecord> getApproveByXmId(Map map);

    /**
     * 修改数据
     *
     * @param prjApproverecord 实例对象
     * @return 影响行数
     */
    int updateApprove(PrjApproverecord prjApproverecord);

    List<PrjApproverecord> getApproveByXmId2(Map map);

    PrjApproverecord getOldApproveRecord(Integer id);

    void updatSpList(@Param("id") String id,@Param("userId") Integer userId);
}

